"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Test = void 0;
var tslib_1 = require("tslib");
var css_1 = require("@platform/css");
var ui_button_1 = require("@platform/ui.button");
var ui_dev_1 = require("@platform/ui.dev");
var React = require("react");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var __1 = require("..");
var DEFAULT = {
    VALUE: '=IF(A1:B2, TRUE, FALSE) / 100',
};
var Test = (function (_super) {
    tslib_1.__extends(Test, _super);
    function Test() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: DEFAULT.VALUE,
        };
        _this.unmounted$ = new rxjs_1.Subject();
        _this.state$ = new rxjs_1.Subject();
        _this.events$ = new rxjs_1.Subject();
        _this.inputRef = function (ref) { return (_this.input = ref); };
        return _this;
    }
    Test.prototype.componentDidMount = function () {
        var _this = this;
        this.state$.pipe(operators_1.takeUntil(this.unmounted$)).subscribe(function (e) { return _this.setState(e); });
        var events$ = this.events$.pipe(operators_1.takeUntil(this.unmounted$));
        events$
            .pipe(operators_1.filter(function (e) { return e.type === 'INPUT/formula/tab'; }), operators_1.map(function (e) { return e.payload; }))
            .subscribe(function (e) {
        });
        events$
            .pipe(operators_1.filter(function (e) { return e.type === 'INPUT/formula/enter'; }), operators_1.map(function (e) { return e.payload; }))
            .subscribe(function (e) {
            if (!e.modifierKeys.shift) {
                e.cancel();
            }
        });
        events$
            .pipe(operators_1.filter(function (e) { return e.type === 'INPUT/formula/changing'; }), operators_1.map(function (e) { return e.payload; }))
            .subscribe(function (e) {
        });
        events$
            .pipe(operators_1.filter(function (e) { return e.type === 'INPUT/formula/changed'; }), operators_1.map(function (e) { return e.payload; }))
            .subscribe(function (e) {
            _this.state$.next({ value: e.to });
        });
    };
    Test.prototype.componentWillUnmount = function () {
        this.unmounted$.next();
    };
    Test.prototype.render = function () {
        var _this = this;
        var styles = {
            base: css_1.css({
                Absolute: 0,
                Flex: 'horizontal',
            }),
            left: css_1.css({
                width: 180,
                backgroundColor: css_1.color.format(-0.04),
                borderRight: "solid 1px " + css_1.color.format(-0.1),
                fontSize: 14,
                padding: 10,
                lineHeight: 1.6,
            }),
            right: css_1.css({
                flex: 1,
            }),
        };
        return (React.createElement("div", tslib_1.__assign({}, styles.base),
            React.createElement("div", tslib_1.__assign({}, styles.left),
                this.button('value: <empty>', function () { return _this.state$.next({ value: '' }); }),
                this.button('value: DEFAULT', function () { return _this.state$.next({ value: DEFAULT.VALUE }); }),
                React.createElement(ui_dev_1.Hr, null),
                this.button('focus', function () { return _this.input.focus(); }),
                this.button('selectAll', function () { return _this.input.selectAll().focus(); }),
                this.button('cursorToStart', function () { return _this.input.cursorToStart().focus(); }),
                this.button('cursorToEnd', function () { return _this.input.cursorToEnd().focus(); })),
            React.createElement("div", tslib_1.__assign({}, styles.right), this.renderInputs())));
    };
    Test.prototype.button = function (title, handler) {
        var styles = {
            base: css_1.css({ Flex: 'start-start' }),
        };
        return (React.createElement("div", tslib_1.__assign({}, styles.base),
            React.createElement(ui_button_1.Button, { label: title, onClick: handler, block: true })));
    };
    Test.prototype.renderInputs = function () {
        var styles = {
            base: css_1.css({ PaddingX: 20 }),
        };
        return (React.createElement("div", tslib_1.__assign({}, styles.base),
            this.renderInput('default - mode: "spreadsheet"', {
                focusOnLoad: true,
                selectOnLoad: true,
            }, this.inputRef),
            this.renderInput('allowTab: true', { allowTab: true }),
            this.renderInput('maxLength (4)', { maxLength: 4 }),
            this.renderInput('fontSize (16)', { fontSize: 16 }),
            this.renderInput('fontSize (8)', { fontSize: 8 }),
            this.renderInput('multiline (SHIFT + ENTER)', { multiline: true, height: 120 })));
    };
    Test.prototype.renderInput = function (title, props, ref) {
        var styles = {
            base: css_1.css({
                PaddingY: 20,
                borderBottom: "solid 1px " + css_1.color.format(-0.1),
            }),
            title: css_1.css({
                fontSize: 12,
                opacity: 0.5,
            }),
            body: css_1.css({
                marginLeft: 20,
                marginTop: 8,
            }),
        };
        return (React.createElement("div", tslib_1.__assign({}, styles.base),
            React.createElement("div", tslib_1.__assign({}, styles.title), title),
            React.createElement("div", tslib_1.__assign({}, styles.body),
                React.createElement(__1.FormulaInput, tslib_1.__assign({ ref: ref, value: this.state.value, allowTab: false }, props, { "events$": this.events$ })))));
    };
    return Test;
}(React.PureComponent));
exports.Test = Test;
